/*
    Sector input/output functions for exFAT reader
    Windows NT version
 */

#include "fatdtype.h"
#include <windows.h>
#include <stdio.h>
#include <string.h>


/*
  Reads the sector from the physical drive

  char letter - letter of disk
  int sectnum - LBA number of sector

 */
int readsect(int drvnum, fat_int64 sectnum, char *buffer)
{
//  char filename[] = "\\\\.\\?:"; 
  char filename[] = "\\\\.\\PhysicalDrive1";
  HANDLE hDrv; 
  int n;
  DISK_GEOMETRY disk_geometry;
  DWORD BytesReturned;

  unsigned int off_hi, off_lo; // Higher and lower part of the offset


  // Open physical drive as file
  filename[strlen(filename)-1] = '0' + drvnum;
  hDrv = CreateFile(filename, GENERIC_READ, 
                    FILE_SHARE_READ || FILE_SHARE_WRITE,
                    NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
  //printf("%s\n", filename);
  if (hDrv == INVALID_HANDLE_VALUE)
    return 1;



  DeviceIoControl(hDrv,IOCTL_DISK_GET_DRIVE_GEOMETRY,   NULL,  0, 
		(LPVOID) &disk_geometry, sizeof(disk_geometry), &BytesReturned,0); 




  // Read one sector
  //off_lo = (__uint32)(sectnum << 9);
  //off_hi = (__uint32)(sectnum >> 23);
  off_lo = (__uint32)((__uint64)sectnum * disk_geometry.BytesPerSector);
  off_hi = (__uint32)(((__uint64)sectnum * disk_geometry.BytesPerSector) >> 32);
//  printf("readsect %.8X %.8X\n", off_hi, off_lo);
  SetFilePointer(hDrv, off_lo, &off_hi, FILE_BEGIN);
  if (!ReadFile(hDrv, buffer, disk_geometry.BytesPerSector, &n, NULL))
	  {
	  printf("read error at offset %x %x: error %x\n", off_lo, off_hi, GetLastError());
	  }

  // Close physical drive as file
  CloseHandle(hDrv); 
  return 0;  
}

/* 
 */
void dumpsect(char *buffer)
{ int i,j,n,n2;
  for (i=0,n=0,n2=0; i<32; i++)
  { printf("%.5X: ", n); // Offset
    for (j=0; j<16; j++, n++) // Hex codes
      printf("%.2X ", buffer[n]);
    for (j=0; j<16; j++, n2++) // Symbols
    { if (buffer[n2] < ' ')
        printf("."); 
      else
        printf("%c",buffer[n2]);
    }
    printf("\n"); // End of string
  }
}


